from collections import deque, defaultdict
def bfs(g, start, md):
    n = len(g)
    dist = [-1] * (n + 1) 
    dist[start] = 0
    q = deque([start])    
    while q:
        nd = q.popleft()
        cd = dist[nd]      
        if cd == md:
            continue         
        for ss in g[nd]:
            if dist[ss] == -1:  
                dist[ss] = cd + 1
                q.append(ss)
    rr = set()
    for i in range(1, n + 1):
        if dist[i] != -1 and dist[i] <= md:
            rr.add(i)
    return rr
def sl(n, m, k, roads, gd):
    if m == 0:
        print(1)
        print(gd[0][0])
        return
    g = defaultdict(list)
    for ai, bi in roads:
        g[ai].append(bi)
        g[bi].append(ai)
    gg = set()
    for pi, hi in gd:
        rr = bfs(g, pi, hi)
        gg.update(rr)
    gg = sorted(gg)
    print(len(gg))
    if gg:
        print(" ".join(map(str, gg)))
    else:
        print()
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
gd = [tuple(map(int, input().split())) for _ in range(k)]
sl(n, m, k, roads, gd)